<?
session_start();

if($_SESSION["ddosblocked"]=='1')
{
	echo "<br><br><br><br><br><span style=\"font-size: 16px; font-weight: bold; color:#ff0000\"><center>Вам временно заблокирован доступ по причине высокой нагрузки на сайт. Попробуйте зайти на сайт немного позже</center></span>";
	exit();
}

$res=mysql_query("select price from tb_config where item='ddosmaxhits'");
$res=mysql_fetch_array($res);
$maxhits=$res["price"];

$res=mysql_query("select price from tb_config where item='ddosperiod'");
$res=mysql_fetch_array($res);
$period=$res["price"];

$res=mysql_query("select price from tb_config where item='ddoscrits'");
$res=mysql_fetch_array($res);
$maxcrit=$res["price"];


if(!isset($_SESSION["ddostime"]))
{
	$t=time();
	$_SESSION["ddostime"]=$t;
	$_SESSION["ddoscrit"]=0;

	$loading=0;

	$blocked='0';

	$nameus=$_SESSION["username"];

	$res = mysql_query("SELECT lastvisit FROM users_online WHERE visitor = '$ip'");
	if(mysql_num_rows($res) == 0)
	{
		mysql_query("INSERT INTO users_online (visitor,lastvisit,user,loading,blocked) VALUES('$ip', '$t', '$nameus', '$loading','$blocked')");
	}else{
		mysql_query("UPDATE users_online SET lastvisit = '$t', loading='$loading', blocked='$blocked', user='$nameus' WHERE visitor = '$ip'");
	}
}else{
	$t=time();
	$lt=$_SESSION["ddostime"];
	$crit=$_SESSION["ddoscrit"];
	$_SESSION["ddostime"]=$t;
	
	$per=$t-$lt;
	$per1=$period/$maxhits;
	if($per!=0){$loading=($per1/$per)*100;}else{$loading=100;}
	$loading=round($loading,2);
	if($loading>100) $loading=100;

	if($loading==100) $crit=$crit+1;
	$_SESSION["ddoscrit"]=$crit;

	if($loading==100 && $crit>$maxcrit) { $blocked='1'; }else{ $blocked='0';}

	$nameus=$_SESSION["username"];

	$res = mysql_query("SELECT lastvisit FROM users_online WHERE visitor = '$ip'");
	if(mysql_num_rows($res) == 0)
	{
		mysql_query("INSERT INTO users_online (visitor,lastvisit,user,loading,blocked) VALUES('$ip', '$t', '$nameus', '$loading','$blocked')");
	}else{
		mysql_query("UPDATE users_online SET lastvisit = '$t', loading='$loading', blocked='$blocked', user='$nameus' WHERE visitor = '$ip'");
	}

	if($blocked=='1')
	{
		$_SESSION["ddosblocked"]='1';
		echo "<br><br><br><br><br><span style=\"font-size: 16px; font-weight: bold; color:#ff0000\"><center>Вам временно заблокирован доступ по причине высокой нагрузки на сайт. Попробуйте зайти на сайт немного позже</center></span>";
		exit();
	}
}
?>